<template>
  <div id="embedded-genome-browser"></div>
</template>

<script setup lang="ts">
/* eslint-disable */
import assembly from "~/utils/config/genomebrowser/assembly.json";
import tracks from "~/utils/config/genomebrowser/tracks.json";
import defaultSession from "~/utils/config/genomebrowser/default_session.json";
import configuration from "~/utils/config/genomebrowser/configuration.json";

const props = defineProps<{ location: string }>();
const mainSpecies = useMainSpecies();
const zoomedInLocation = computed(() => {
  const [seq, coords] = props.location.split(":");
  const [startStr, endStr] = coords.split("..");

  const start = parseInt(startStr);
  const end = parseInt(endStr);
  const halfLength = (end - start) / 2;

  const zoomedInStart = start - halfLength < 0 ? 0 : start - halfLength;
  const zoomedInEnd = end + halfLength;
  return {
    refName: seq,
    start: parseInt(zoomedInStart),
    end: parseInt(zoomedInEnd),
  };
});
const zoomedInLocationStr = computed(() => {
  return `${zoomedInLocation.value.refName}:${zoomedInLocation.value.start}..${zoomedInLocation.value.end}`;
});

onMounted(() => {
  console.log
  const { createViewState, JBrowseLinearGenomeView } =
    JBrowseReactLinearGenomeView;

  let viewState;
  const { $config } = useNuxtApp();
  if (mainSpecies !== 'Tcas') {
    const baseURL = $config.public.uiPages.genomebrowser;
    viewState = new createViewState({
      assembly: {
        name: "genomic.fna",
        sequence: {
          type: "ReferenceSequenceTrack",
          trackId: "genomic.fna",
          adapter: {
            type: "IndexedFastaAdapter",
            fastaLocation: {
              uri: `${baseURL}/data/genomic.fna`,
              locationType: "UriLocation",
            },
            faiLocation: {
              uri: `${baseURL}/data/genomic.fna.fai`,
              locationType: "UriLocation",
            },
          },
        },
      },
      tracks: [
        {
          type: "FeatureTrack",
          trackId: "genomic.sorted.gff",
          name: "genomic.sorted.gff",
          adapter: {
            type: "Gff3TabixAdapter",
            gffGzLocation: {
              uri: `${baseURL}/data/genomic.sorted.gff.gz`,
              locationType: "UriLocation",
            },
            index: {
              location: {
                uri: `${baseURL}/data/genomic.sorted.gff.gz.tbi`,
                locationType: "UriLocation"
              },
              indexType: "TBI",
            }
          },
          assemblyNames: [
            "genomic.fna",
          ],
        },
      ],
      defaultSession: {
        name: "default",
        view: {
          type: "LinearGenomeView",
          tracks: [
            {
              type: "FeatureTrack",
              configuration: "genomic.sorted.gff",
              displays: [
                {
                  type: 'LinearBasicDisplay',
                  configuration: 'genomic.sorted.gff-LinearBasicDisplay',
                  height: 180,
                },
              ],
            },
          ],
          hideHeader: true,
          hideHeaderOverview: true,
          hideNoTracksActive: true,
          trackSelectorType: "hierarchical",
          trackLabels: "offset",
          showCenterLine: false,
          showCytobandsSetting: false,
          showGridlines: true,
        },
      },
      configuration,
      location: zoomedInLocationStr.value,
    });
  } else {
    viewState = createViewState({
      assembly,
      tracks,
      defaultSession,
      configuration,
      location: zoomedInLocationStr.value,
    });
  }
  const domContainer = document.getElementById("embedded-genome-browser");

  ReactDOM.render(
    React.createElement(JBrowseLinearGenomeView, { viewState }),
    domContainer,
  );
});
</script>

<style>
#embedded-genome-browser > div > div > div {
  box-shadow: none;
  padding: 0;
}

#embedded-genome-browser > div > div > div > div:first-child {
  height: 0;
}
</style>
